(*
  LapView p̃oCif[^Cu

20100814
EA`FbNŤ؂͍sĂȂ

*)
unit LapViewLib;

interface

uses
	Windows, Messages, SysUtils, Classes;

type
(*
  LapView ̓ 2byte f[^ׂ͂ărbOGfBA
  gGfBA x86 nł̓GfBAϊKv
*)
  // LapView f[^wb_
  TLVHead = array[0..2] of Char;

  // LapView f[^^Cv
  TLVDataType = (
    ldtUnknown, // m̃f[^`
    ldtIn,      // i[f[^M[h f[^
    ldtId       // IDo̓m[}[h f[^
  );

  // LapView bvf[^ 60  WORD ^z = 120byte
  TLVLapData = array[0..59] of WORD;  // (2byte,Hi-Low̏,LSB10ms)

  // LapView EEPROM f[^ 128byte
  TLVRomData = packed record
    LapData   : TLVLapData; // 120byte  bv^Cf[^
    ID        : BYTE;       // 1byte    vID
    LapCount  : BYTE;       // 1byte    vbv
    Target    : WORD;       // 2byte    ڕW^C (2byte,Hi-Low̏,LSB10ms)
    MinTime   : BYTE;       // 1byte    vŏ^C(LSB1sec)           
    MaxTime   : BYTE;       // 1byte    vő^C(LSB1sec)
    RaceTime  : BYTE;       // 1byte    [X^C(LSB1min)
    Mode      : BYTE;       // 1byte    [h(0 = K; 1 = [X;)
  end;

  // LapView f[^ 134byte
  TLVInData = packed record
    Head      : TLVHead;    // 3byte    f[^ wb_R[h($FF)
    LVType    : BYTE;       // 1byte    LapView @R[h
    Version   : BYTE;       // 1byte    LapView o[WR[h
    RomData   : TLVRomData; // 128byte  EEPROM f[^
    CheckSum  : BYTE;       // 1byte    `FbNT (4-133byte ̘ả 1byte)
  end;

  // ID f[^ 7byte
  TLVIdData = packed record
    Head      : TLVHead;  // 3byte  ID f[^ wb_R[h($FE)
    ID        : BYTE;     // 1byte  ID
    TimeCount : WORD;     // 2byte  ^CJEg (2byte,Hi-Low̏,LSB10ms)
                          // ^C-O^C = bv^C
    CheckSum  : BYTE;     // 1byte  (L4-6̘a)
  end;

  TLVMode = (lvmPractice, lvmRace);

  TLapData = array[0..59] of Single; 

  // TLVInData ₷^ɕϊ\
  TInData = record
    LVType    : BYTE;
    Version   : BYTE;
    LapData   : TLapData;
    ID        : BYTE;
    LapCount  : BYTE;
    Target    : Single;
    MinTime   : BYTE;
    MaxTime   : BYTE;
    RaceTime  : BYTE;
    Mode      : TLVMode;
  end;

  // TLVIdData ₷^ɕϊ\
  TIdData = record
    ID        : BYTE;
    TimeCount : WORD;
  end;

// GfBAϊ(WORD^)
function Endian(x: WORD): WORD;

// `FbNT쐬
function GetCheckSum(InData: TLVInData): Byte; overload;
function GetCheckSum(IdData: TLVIdData): Byte; overload;

// LapView f[^^Cv
function GetLVDataType(Data: TStream): TLVDataType;
// Stream  TLVInData ɕϊ
function DataToInData(Data: TStream; out InData: TLVInData): Boolean;
// Stream  TLVIdData ɕϊ
function DataToIdData(Data: TStream; out IdData: TLVIdData): Boolean;

// f[^ϊ
procedure ConvInData(Src: TLVInData; out Dst: TInData);
procedure ConvIdData(Src: TLVIdData; out Dst: TIdData);

implementation

// GfBAϊ(WORD^)
function Endian(x: WORD): WORD;
begin
  asm
	  bswap	eax
  end;
  Result  := X;
end;

// `FbNT쐬
function GetCheckSum(InData: TLVInData): Byte; overload;
(*
var
  Buf: TMemoryStream;
  B: BYTE;
  C: DWORD;
  i: Integer;
*)
begin
  Result := 0;
(*
  // `FbNT (4-133byte ̘ả 1byte)
  Buf := TMemoryStream.Create;
  try
    Buf.Write(InData, SizeOf(TLVInData));
    // 擪4oCgڂɈړ
    Buf.Seek(SizeOf(TLVHead), soFromBeginning);
    // 130 oCg[v
    C := 0;
    for i := 0 to 129 do begin
      Buf.Read(B, SizeOf(BYTE));
      Inc(C, B);
    end;
  finally
    Buf.Free;
  end;
*)
end;

function GetCheckSum(IdData: TLVIdData): Byte; overload;
begin
  Result  := 0;
end;

// LapView f[^^Cv
function GetLVDataType(Data: TStream): TLVDataType;
var
  Head: TLVHead;
begin
  Result := ldtUnknown;
  
  // Data 擪Ɉړ
  Data.Seek(0, soFromBeginning);
  // Data ̐擪 3byte [h
  Data.Read(Head, SizeOf(TLVHead));

  // Data 擪ɖ߂
  Data.Seek(0, soFromBeginning);

  if Head = #$FF then
    Result := ldtIn
  else if Head = #$FE then
    Result := ldtId;
end;

// Stream  TLVInData ɕϊ
function DataToInData(Data: TStream; out InData: TLVInData): Boolean;
(*
var
  Sum: Byte;
*)
begin
  Result := False;

  // InData 
  FillChar(InData, SizeOf(TLVInData), #0);

  // Data ̃wb_`FbN
  if GetLVDataType(Data) <> ldtIn then
    // wb_ sȂ̂ŏI
    Exit;

  // Data ̃TCY`FbN
  if Data.Size < SizeOf(TLVInData) then
    // Data ̃TCY SizeOf(TLVInData) 菬 (134byte ȉ) ̂ŏI
    Exit;

  // Data 擪Ɉړ
  Data.Seek(0, soFromBeginning);
  // Data  InData [h
  Data.Read(InData, SizeOf(TLVInData));

(*
  // `FbNT쐬
  Sum := GetCheckSum(InData);
  // `FbNT
  if not InData.CheckSum <> Sum then
    // `FbNTsȂ߃G[
    Exit;
*)
  // Ō True
  Result := True;
end;

// Stream  TLVIdData ɕϊ
function DataToIdData(Data: TStream; out IdData: TLVIdData): Boolean;
begin
  Result := False;

  // IdData 
  FillChar(IdData, SizeOf(TLVIdData), #0);

  // Data ̃wb_`FbN
  if GetLVDataType(Data) <> ldtId then
    // wb_ sȂ̂ŏI
    Exit;

  // Data 擪Ɉړ
  Data.Seek(0, soFromBeginning);
  // Data  IdData [h
  Data.Read(IdData, SizeOf(TLVIdData));

  // Ō True
  Result := True;
end;

// f[^ϊ
procedure ConvInData(Src: TLVInData; out Dst: TInData);
var
  i: Integer;
begin
  Dst.LVType    := Src.LVType;
  Dst.Version   := Src.Version;
  Dst.ID        := Src.RomData.ID;
  Dst.LapCount  := Src.RomData.LapCount;
  Dst.Target    := Endian(Src.RomData.Target) / 100;  // GfBAϊ
  Dst.MinTime   := Src.RomData.MinTime;
  Dst.MaxTime   := Src.RomData.MaxTime;
  Dst.RaceTime  := Src.RomData.RaceTime;
  Dst.Mode      := TLVMode(Src.RomData.Mode);
  for i := 0 to Length(Dst.LapData) - 1 do
    // GfBAϊ
    Dst.LapData[i] := Endian(Src.RomData.LapData[i]) / 100;
end;

procedure ConvIdData(Src: TLVIdData; out Dst: TIdData);
begin
  Dst.ID        := Src.ID;
  Dst.TimeCount := Endian(Src.TimeCount);
end;

end.
